/* Menu.java
 */
import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.StringTokenizer;

/**
 * <p>This is a very simple menu applet that lets you add menu navigation to 
 * your website. It is available free from my website 
 * <a href="http://www.ratrobot.com">ratrobot.com</a>
 * under the terms of the 
 * <a href="http://www.fsf.org/licenses/licenses.html">General Public License</a>
 * </p>
 *
 * <p>This is a very old ( several years ) applet that I wrote when I started
 *   playing with Java. I have no plans to update it in the future. 
 * </p>
 * @auther Cat
 * @version 1.0
 */
public class Menu extends Applet  implements ItemListener
{
    /**The menu displayed in the applet*/
    private Choice m_menu;

    /**Image used for a tiled image background*/
    private Image m_image;

    public void init()
    {
        m_menu = new Choice();
        
        //Get all of the parameters named item<number> starting at item1 untill
        //item<n> does not exist.
        String s = "";
        for(int i = 0; s != null; i++)
        {
            s = getParameter("item" + i);
            if(s != null)
            {
                m_menu.addItem(s);
            }
        }

        setBackground(colorBuilder("background"));
        m_menu.addItemListener(this);
        m_menu.setBackground(colorBuilder("menucolor"));
        m_menu.setFont(fontBuilder());
        m_menu.setForeground(colorBuilder("fontcolor"));
        add(m_menu);
    }
    
    public void paint(Graphics g)
    {
        Cursor cursor = new Cursor(Cursor.HAND_CURSOR);
        m_menu.setCursor(cursor);
        showStatus("FREE applet from www.ratrobot.com");
        if(m_image != null)
        {
            backGround(g, m_image);
        }
    }

    /**Gets the url from the applet parameter for the selected index and 
     *  redirects the applet to that page. The parameter is of the form 
     * &quot;http://www.mysite.com/,main&quot; where main is a window or frame
     * name.
     */
    public void itemStateChanged(ItemEvent itemevent)
    {
        String s = getParameter("url" + m_menu.getSelectedIndex());
        StringTokenizer stringtokenizer = new StringTokenizer(s, ",");
        AppletContext appletcontext = getAppletContext();
        try
        {
            String s1 = stringtokenizer.nextToken();
            URL url = new URL(getDocumentBase(), s1);
            
            //If you specify a frame or window name use it otherwise use this one
            if(stringtokenizer.hasMoreTokens())
            {
                String s2 = stringtokenizer.nextToken();
                appletcontext.showDocument(url, s2);
                return;
            } 
            else
            {
                appletcontext.showDocument(url);
                return;
            }
        }
        catch(MalformedURLException _ex)
        {
            //Don't attempt to redirect
        }
    }

    /**Takes a parameter string of the form 100,200,100 and returns a 
     * java.awt.Color. Also handles background images. Probably want to handle
     * background images with a separate parameter rather than this hack :).
     */
    private Color colorBuilder(String s)
    {
        Color color = Color.white;
        try
        {
            StringTokenizer st = new StringTokenizer(getParameter(s), ",");
            color = new Color(Integer.parseInt(st.nextToken()), 
                              Integer.parseInt(st.nextToken()), 
                              Integer.parseInt(st.nextToken())
                             );
        }
        catch(Exception e)
        {
            if(s.equalsIgnoreCase("background"))
            {
                m_image = getImage(getDocumentBase(), getParameter("background"));
            }
            else if(s.equalsIgnoreCase("fontcolor"))
            {
                color = Color.black;
            }
        }
        return color;
    }

    /**Takes a parameter string of the form serif,bold,10 and returns a 
     * java.awt.Font.
     */
    private Font fontBuilder()
    {
        //default values for font
        String s2 = "Serif";
        int i = 0;
        int j = 12;
        
        String s = getParameter("font");
        try
        {
            StringTokenizer stringtokenizer = new StringTokenizer(s, ",", false);
            s2 = stringtokenizer.nextToken();
            String s1 = stringtokenizer.nextToken();
            if(s1.equalsIgnoreCase("bold"))
            {
                i += Font.BOLD;
            }
            else if(s1.equalsIgnoreCase("italic"))
            {
                i += Font.ITALIC;
            }
            else if(s1.equalsIgnoreCase("bolditalic"))
            {
                i += Font.BOLD + Font.ITALIC;
            }
            try
            {
                j = Math.abs(Integer.parseInt(stringtokenizer.nextToken()));
            }
            catch(NumberFormatException e) 
            { 
                //Leave the default values
            }
        }
        catch(Exception e) 
        { 
            //Leave the default values
        }
        Font font = new Font(s2, i, j);
        return font;
    }

    /**Creates a tiled image background for the applet if an image is supplied.*/
    private void backGround(Graphics g, Image image)
    {
        int i1 = 0;
        boolean flag = false;
        int i = image.getWidth(this);
        int j = image.getHeight(this);
        int k = getSize().width;
        int l = getSize().height;
        if(i != -1 && j != -1)
            for(; i1 < k; i1 += i)
            {
                for(int j1 = 0; j1 < l; j1 += j)
                {
                    g.drawImage(image, i1, j1, this);
                }

            }

    }
}
